## mediastreamer2 5.2.0+dfsg

=== build/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

cmake_minimum_required(VERSION 3.11) # we need CMake 3.11 for defining 'package_source' target as custom target

if(NOT CPACK_PACKAGE_NAME)
	set(CPACK_PACKAGE_NAME "mediastreamer")
endif()

set(CPACK_SOURCE_IGNORE_FILES
	"${CMAKE_BINARY_DIR}"
	"^${PROJECT_SOURCE_DIR}/.git*"
)

bc_make_package_source_target()

=== help/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

find_package(Doxygen)

if(DOXYGEN_FOUND)
	if(DOXYGEN_DOT_FOUND)
                set(top_srcdir ${PROJECT_SOURCE_DIR})
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
		file(GLOB DOC_INPUT_FILES
			[^.]*.dox
			../include/mediastreamer2/[^.]*.h
			src/[^.]*/[^.]*.h
			src/[^.]*/[^.]*.c
		)
		add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html"
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile ${DOC_INPUT_FILES}
		)
		add_custom_target(ms2-html-doc ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html")
		install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc/html"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/mediastreamer2-${MEDIASTREAMER_VERSION}")
	else()
		message(WARNING "The dot program is needed to generate the mediastreamer2 documentation. You can get it from http://www.graphviz.org/.")
	endif()
endif()

=== include/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(HEADER_FILES
	allfilters.h
	android_utils.h
	bitratecontrol.h
	bits_rw.h
	box-plot.h
	devices.h
	dsptools.h
	dtls_srtp.h
	dtmfgen.h
	flowcontrol.h
	formats.h
	ice.h
	mediastream.h
	ms_srtp.h
	msaudiomixer.h
	mschanadapter.h
	mscodecutils.h
	mscommon.h
	msconference.h
	msequalizer.h
	mseventqueue.h
	msextdisplay.h
	msanalysedisplay.h
	msfactory.h
	msfileplayer.h
	msfilerec.h
	msfilter.h
	msgenericplc.h
	msinterfaces.h
	msitc.h
	msjava.h
	msjpegwriter.h
	msogl.h
	msogl_functions.h
	msqrcodereader.h
	msmediaplayer.h
	msmediarecorder.h
	msqueue.h
	msrtp.h
	mssndcard.h
	mstee.h
	msticker.h
	mstonedetector.h
	msutils.h
	msv4l.h
	msvaddtx.h
	msvideo.h
	msvideoout.h
	msvideopresets.h
	msvideoqualitycontroller.h
	msvolume.h
	mswebcam.h
	qualityindicator.h
	rfc3984.h
	stun.h
	upnp_igd.h
	x11_helper.h
	zrtp.h
	msrtt4103.h
	msasync.h
	msudp.h
	mspcapfileplayer.h
	msvideoswitcher.h
	msanalysedisplay.h
	msmire.h
	msvideorouter.h
)

set(MEDIASTREAMER2_HEADER_FILES )
foreach(HEADER_FILE ${HEADER_FILES})
	list(APPEND MEDIASTREAMER2_HEADER_FILES "${CMAKE_CURRENT_LIST_DIR}/mediastreamer2/${HEADER_FILE}")
endforeach()
set(MEDIASTREAMER2_HEADER_FILES ${MEDIASTREAMER2_HEADER_FILES} PARENT_SCOPE)

install(FILES ${MEDIASTREAMER2_HEADER_FILES}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mediastreamer2
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)
if(ENABLE_VIDEO)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/OpenGL
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	)

endif()

=== src/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

find_library(LIBM NAMES m)

find_program(AWK_PROGRAM awk CMAKE_FIND_ROOT_PATH_BOTH)
if(NOT AWK_PROGRAM)
	message(FATAL_ERROR "You need the awk program to build mediastreamer2.")
endif()

set(BASE_SOURCE_FILES_C
	base/eventqueue.c
	base/mscommon.c
	base/msfactory.c
	base/msfilter.c
	base/msqueue.c
	base/mssndcard.c
	base/msticker.c
	base/msvideopresets.c
	base/mswebcam.c
	base/mtu.c
	base/msasync.c
	otherfilters/itc.c
	otherfilters/join.c
	otherfilters/tee.c
	otherfilters/void.c
)
if(ANDROID)
	list(APPEND BASE_SOURCE_FILES_C utils/msjava.c)
endif()

bc_git_version(ms2 ${PROJECT_VERSION})

add_definitions(
	-D_TRUE_TIME
	-DMS2_EXPORTS
	-DMS2_INTERNAL
	-DMS2_FILTERS
)
if(DISABLE_SRTP_SEARCH)
	# Set -DSRTP_INTERNAL in order to include srtp.h instead of srtp2/srtp.h
	add_compile_definitions(SRTP_INTERNAL)
endif()

set(VOIP_SOURCE_FILES_C
	audiofilters/alaw.c
	audiofilters/audiomixer.c
	audiofilters/chanadapt.c
	audiofilters/devices.c
	audiofilters/dtmfgen.c
	audiofilters/equalizer.c
	audiofilters/flowcontrol.c
	audiofilters/g711.c
	audiofilters/g711.h
	audiofilters/genericplc.h
	audiofilters/genericplc.c
	audiofilters/msgenericplc.c
	audiofilters/l16.c
	audiofilters/msfileplayer.c
	audiofilters/msfilerec.c
	audiofilters/asyncrw.c
	audiofilters/asyncrw.h
	audiofilters/msg722.c
	audiofilters/msvaddtx.c
	audiofilters/msvolume.c
	audiofilters/tonedetector.c
	audiofilters/ulaw.c
	audiofilters/waveheader.h
	crypto/dtls_srtp.c
	crypto/ms_srtp.c
	crypto/zrtp.c
	otherfilters/msrtp.c
	utils/_kiss_fft_guts.h
	utils/audiodiff.c
	utils/box-plot.c
	utils/dsptools.c
	utils/g722.h
	utils/g722_decode.c
	utils/g722_encode.c
	utils/kiss_fft.c
	utils/kiss_fft.h
	utils/kiss_fftr.c
	utils/kiss_fftr.h
	utils/pcap_sender.c
	utils/pcap_sender.h
	utils/stream_regulator.c
	utils/srtp_prefix.h
	voip/audioconference.c
	voip/audiostream.c
	voip/bandwidthcontroller.c
	voip/bitratecontrol.c
	voip/bitratedriver.c
	voip/ice.c
	voip/mediastream.c
	voip/msiframerequestslimiter.c
	voip/msmediaplayer.c
	voip/msmediarecorder.c
	voip/msvoip.c
	voip/private.h
	voip/qosanalyzer.c
	voip/qosanalyzer.h
	voip/qualityindicator.c
	otherfilters/rfc4103_source.c
	otherfilters/rfc4103_sink.c
	otherfilters/msudp.c
	voip/rfc4103_textstream.c
	voip/ringstream.c
	voip/stun.c
	voip/offeranswer.c
	voip/private.h
)
set(VOIP_SOURCE_FILES_CXX
	utils/filter-wrapper/decoding-filter-wrapper.cpp
	utils/filter-wrapper/encoding-filter-wrapper.cpp
	voip/audiostreamvolumes.cpp
	voip/turn_tcp.cpp
	voip/video-conference.cpp
	voip/video-conference-all-to-all.cpp
	voip/video-endpoint.cpp
)
set(VOIP_SOURCE_FILES_OBJC )
set(VOIP_SOURCE_FILES_ASM )

if (APPLE)
        list(APPEND VOIP_SOURCE_FILES_OBJC utils/apple_utils.h utils/apple_utils.m)
endif()

if(ENABLE_ALSA)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/alsa.c)
endif()
if(ANDROID)
	list(APPEND VOIP_SOURCE_FILES_CXX voip/msvoip_jni.cc)
endif()
if(ENABLE_ANDROIDSND)
	list(APPEND VOIP_SOURCE_FILES_CXX
		android/androidsound_utils.cpp
		android/androidsound.cpp
		android/androidsound_depr.cpp
		android/androidsound_opensles.cpp
		android/AudioRecord.cpp
		android/AudioSystem.cpp
		android/AudioTrack.cpp
		android/hardware_echo_canceller.cpp
		android/loader.cpp
		android/String8.cpp
		#audiofilters/aac-eld-android.cpp
		#Not working on Android, to be fix
	)
endif()
if(ENABLE_ARTSC)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/arts.c)
endif()
if(ENABLE_MACSND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/macsnd.c)
endif()
if(ENABLE_MACAQSND)
	list(APPEND VOIP_SOURCE_FILES_OBJC audiofilters/aqsnd.m)
endif()
if(ENABLE_OSS)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/oss.c)
endif()
if(ENABLE_PORTAUDIO)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/pasnd.c)
endif()
if(ENABLE_PULSEAUDIO)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/pulseaudio.c)
endif()
if(ENABLE_QSA)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/qsa.c)
endif()
if(APPLE)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/aac-eld.c)
endif()
if(IOS)
	list(APPEND VOIP_SOURCE_FILES_OBJC audiofilters/msiounit.mm)
endif()

if(ENABLE_G726)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/g726.c)
endif()
if(BCG729_FOUND AND ENABLE_G729)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/g729.c)
endif()
if(GSM_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/gsm.c)
endif()
if(BV16_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/bv16.c)
endif()
if(OPUS_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/msopus.c)
endif()
if(ENABLE_RESAMPLE)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/msresample.c)
endif()
if(SPEEX_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/msspeex.c)
endif()
if(SPEEXDSP_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/speexec.c)
endif()

if(ENABLE_VIDEO)
	list(APPEND VOIP_SOURCE_FILES_C
		utils/bits_rw.c
		videofilters/extdisplay.c
		videofilters/msanalysedisplay.c
		videofilters/mire.c
		videofilters/nowebcam.c
		videofilters/pixconv.c
		videofilters/sizeconv.c
		videofilters/videoswitcher.c
		videofilters/videorouter.c
		voip/layouts.c
		voip/layouts.h
		voip/msvideo_neon.c
		voip/msvideo_neon.h
		voip/msvideo.c
		voip/msvideoqualitycontroller.c
		voip/nowebcam.h
		voip/rfc2429.h
		voip/video_preset_high_fps.c
		voip/videostarter.c
		voip/videostream.c
		voip/vp8rtpfmt.c
		voip/vp8rtpfmt.h
	)
	if(FFMPEG_FOUND AND NOT TURBOJPEG_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/jpgloader-ffmpeg.c
		)
	elseif(TURBOJPEG_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/jpgloader-turbojpeg.c
		)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/msturbojpeg.cpp	#MJPEG using turbojpeg
		)
	else()
		list(APPEND VOIP_SOURCE_FILES_C
			utils/jpgloader-stub.c
		)
	endif()
	if(ENABLE_QT_GL)
		set(QT_VOIP_SOURCE_FILES_CXX videofilters/msqogl.cpp )
	endif()
	if(WIN32)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/msmfoundationcap.cpp	#Media-Foundation
			videofilters/msmfoundationcap.h
		)
	    if(NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsPhone" AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
			add_definitions(-DHAVE_DIRECTSHOW)
			if(NOT(ENABLE_MICROSOFT_STORE_APP))
				list(APPEND VOIP_SOURCE_FILES_C videofilters/drawdib-display.c)
			endif()
			list(APPEND VOIP_SOURCE_FILES_CXX
				videofilters/msdscap.cc				#DirectShow
			)
		elseif(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /ZW /EHsc /await")
	    endif()
	endif()
	if(APPLE)
		if(IOS)
			list(APPEND VOIP_SOURCE_FILES_C
				utils/opengl_functions.c
				utils/opengl_functions.h
				utils/opengles_display.c
				utils/opengles_display.h
				utils/shader_util.c
				utils/shader_util.h
				voip/scaler.c
			)
			list(APPEND VOIP_SOURCE_FILES_OBJC
				videofilters/iosdisplay.mm
				videofilters/ioscapture.m
				voip/ioshardware.m
			)
		else()
			list(APPEND VOIP_SOURCE_FILES_OBJC
				videofilters/msosxdisplay.m
				videofilters/avfound-capture.m
			)

			list(APPEND VOIP_SOURCE_FILES_C
				utils/opengl_functions.c
				utils/opengl_functions.h
				utils/opengles_display.c
				utils/opengles_display.h
				utils/shader_util.c
				utils/shader_util.h
			)
		endif()
	endif()
	if(ANDROID)
		list(APPEND VOIP_SOURCE_FILES_C
			android/android-display.c
			android/android-opengl-display.c
			android/android-texture-display.c
			utils/opengl_functions.c
			utils/opengl_functions.h
			utils/opengles_display.c
			utils/opengles_display.h
			utils/shader_util.c
			utils/shader_util.h
			voip/scaler.c
		)
		if(CMAKE_SYSTEM_PROCESSOR STREQUAL "armv7-a")
			list(APPEND VOIP_SOURCE_FILES_ASM
				voip/scaler_arm.S
			)
		endif()
		list(APPEND VOIP_SOURCE_FILES_CXX
			android/android_mediacodec.cpp
			android/android-display-bad.cpp
			android/androidvideo.cpp
		)
	endif()
	if (ENABLE_QNX)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/bb10_display.cpp
			videofilters/bb10_capture.cpp
		)
	endif()
	if(FFMPEG_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/ffmpeg-priv.c
			utils/ffmpeg-priv.h
			videofilters/videodec.c
			videofilters/videoenc.c
		)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/h264dec.cpp
		)
		if(NOT TURBOJPEG_FOUND)
			list(APPEND VOIP_SOURCE_FILES_C
				videofilters/ffmpegjpegwriter.c
			)
		endif()
	endif()
	if(TURBOJPEG_FOUND)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/turbojpegwriter.c
		)
	endif()
	if(ZXING_FOUND)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/zxing_qrcode.cpp
		)
	endif()
	if(WIN32)
		list(APPEND VOIP_SOURCE_FILES_CXX
			utils/opengl_functions.c
			utils/opengles_display.c
			utils/shader_util.c
			videofilters/generic_opengl_display.c
		)
	elseif(OPENGL_FOUND OR QTANGLE_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/opengl_functions.c
			utils/opengles_display.c
			utils/shader_util.c
			videofilters/generic_opengl_display.c
		)
	endif()
	if(GLX_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/opengl_functions.c
			utils/opengles_display.c
			utils/shader_util.c
			videofilters/glxvideo.c
		)
	endif()
	if(SDL_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/videoout.c)
	endif()
	if(THEORA_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/theora.c)
	endif()
	if(V4L_FOUND)
		if(HAVE_LINUX_VIDEODEV_H)
			list(APPEND VOIP_SOURCE_FILES_C videofilters/msv4l.c)
		endif()
		if(HAVE_LINUX_VIDEODEV2_H)
			list(APPEND VOIP_SOURCE_FILES_C videofilters/msv4l2.c)
		endif()
	endif()
	if(VPX_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			videofilters/vp8.c
		)
	endif()
	if(X11_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C utils/x11_helper.c)
	endif()
	if(XV_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/x11video.c)
	endif()
endif()
if(BCMATROSKA2_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C
		voip/rfc2429.h
	)
	list(APPEND VOIP_SOURCE_FILES_CXX
		utils/mkv_reader.cpp
		videofilters/mkv.cpp
	)
endif()

if(PCAP_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C otherfilters/mspcapfileplayer.c)
endif()

if(ENABLE_VIDEO)
	add_subdirectory(voip/h26x)
endif()

set(VOIP_SOURCE_FILES_ALL ${VOIP_SOURCE_FILES_C} ${VOIP_SOURCE_FILES_CXX} ${VOIP_SOURCE_FILES_OBJC} ${VOIP_SOURCE_FILES_ASM})
set(SOURCE_FILES_ALL ${BASE_SOURCE_FILES_C} ${VOIP_SOURCE_FILES_ALL})

add_custom_target(ms2-basedescs-header
	COMMAND ${CMAKE_COMMAND} -DAWK_PROGRAM=${AWK_PROGRAM} -DAWK_SCRIPTS_DIR="${CMAKE_CURRENT_SOURCE_DIR}/../"
		-DINPUT_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DOUTPUT_DIR=${CMAKE_CURRENT_BINARY_DIR}
		-DTYPE=base -DSOURCE_FILES="${BASE_SOURCE_FILES_C}"
		-P "${CMAKE_CURRENT_SOURCE_DIR}/generate_descs_header.cmake"
	BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/basedescs.h")

add_custom_target(ms2-voipdescs-header
	COMMAND ${CMAKE_COMMAND} -DAWK_PROGRAM=${AWK_PROGRAM} -DAWK_SCRIPTS_DIR="${CMAKE_CURRENT_SOURCE_DIR}/../"
		-DINPUT_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DOUTPUT_DIR=${CMAKE_CURRENT_BINARY_DIR}
		-DTYPE=voip -DSOURCE_FILES="${VOIP_SOURCE_FILES_ALL}"
		-P "${CMAKE_CURRENT_SOURCE_DIR}/generate_descs_header.cmake"
	BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/voipdescs.h"
)


if(APPLE OR ANDROID OR OPENGL_FOUND OR GLX_FOUND OR QTANGLE_FOUND OR WIN32)
	find_package(PythonInterp 3 REQUIRED)

=== tools/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

string(REPLACE ";" " " LINK_FLAGS_STR "${LINK_FLAGS}")

set(USE_BUNDLE )
if (IOS)
	set(USE_BUNDLE MACOSX_BUNDLE)
endif()

if(ENABLE_SHARED)
	set(MS2_LIBS_FOR_TOOLS mediastreamer)
else()
	set(MS2_LIBS_FOR_TOOLS mediastreamer-static)
	if(XV_FOUND)
		list(APPEND MS2_LIBS_FOR_TOOLS Xext)
	endif()
endif()

set(simple_executables bench ring mtudiscover tones msaudiocmp)
if(ENABLE_VIDEO)
	list(APPEND simple_executables videodisplay)
	if(X11_FOUND)
		list(APPEND simple_executables test_x11window)
	endif()
endif()

foreach(simple_executable ${simple_executables})
	set(${simple_executable}_SOURCE_FILES ${simple_executable}.c)
	bc_apply_compile_flags(${simple_executable}_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(${simple_executable} ${USE_BUNDLE} ${simple_executable}.c)
	target_link_libraries(${simple_executable} ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
	set_target_properties(${simple_executable} PROPERTIES LINKER_LANGUAGE CXX)
	if(LINK_FLAGS_STR)
		set_target_properties(${simple_executable} PROPERTIES LINK_FLAGS "${LINK_FLAGS_STR}")
	endif()
endforeach()

set(ECHO_SOURCE_FILES echo.c)
bc_apply_compile_flags(ECHO_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
add_executable(ms-echo ${USE_BUNDLE} ${ECHO_SOURCE_FILES}) # Do not name the target "echo" to avoid conflict with the shell echo command
set_target_properties(ms-echo PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(ms-echo ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
if(LINK_FLAGS_STR)
	set_target_properties(ms-echo PROPERTIES LINK_FLAGS "${LINK_FLAGS_STR}")
endif()

if(PCAP_FOUND)
	if(APPLE AND NOT IOS)
                set(SOURCE_FILES_OBJC pcap_player_cocoa.m)
        endif()
	bc_apply_compile_flags(SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)

	set(PCAP_PLAYBACK_SOURCE_FILES pcap_playback.c common.c)
	bc_apply_compile_flags(PCAP_PLAYBACK_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(pcap_playback ${USE_BUNDLE} ${PCAP_PLAYBACK_SOURCE_FILES} ${SOURCE_FILES_OBJC})
	set_target_properties(pcap_playback PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(pcap_playback ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
	target_include_directories(pcap_playback PRIVATE ${PCAP_INCLUDE_DIRS})
	if(LINK_FLAGS_STR)
		set_target_properties(pcap_playback PROPERTIES LINK_FLAGS "${LINK_FLAGS_STR}")
	endif()
endif()

if (NOT IOS)
	set(MEDIASTREAM_SOURCE_FILES_C mediastream.c common.c)
	set(MEDIASTREAM_SOURCE_FILES_OBJC )
	if(APPLE)
		list(APPEND MEDIASTREAM_SOURCE_FILES_OBJC mediastream_cocoa.m)
	endif()
	bc_apply_compile_flags(MEDIASTREAM_SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	bc_apply_compile_flags(MEDIASTREAM_SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)
	add_executable(mediastream ${USE_BUNDLE} ${MEDIASTREAM_SOURCE_FILES_C} ${MEDIASTREAM_SOURCE_FILES_OBJC})
	set_target_properties(mediastream PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(mediastream ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
	if(LINK_FLAGS_STR)
		set_target_properties(mediastream PROPERTIES LINK_FLAGS "${LINK_FLAGS_STR}")
	endif()
	install(TARGETS mediastream
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
endif()

if(ENABLE_VIDEO)
	set(MKVSTREAM_SOURCE_FILES mkvstream.c)
	bc_apply_compile_flags(MKVSTREAM_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(mkvstream ${USE_BUNDLE} ${MKVSTREAM_SOURCE_FILES})
	set_target_properties(mkvstream PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(mkvstream ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
	if(LINK_FLAGS_STR)
		set_target_properties(mkvstream PROPERTIES LINK_FLAGS "${LINK_FLAGS_STR}")
	endif()

	if (NOT IOS)
		install(TARGETS mkvstream
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		)
	endif()
endif()

=== debian/changelog ===
mediastreamer2 (1:5.2.0+dfsg-3.2~build2) noble; urgency=medium

  * No-change rebuild against Qt 5.15.13.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 06 Apr 2024 22:42:38 +0300

mediastreamer2 (1:5.2.0+dfsg-3.2~build1) noble; urgency=medium

  * Rename libraries for 64-bit time_t transition.  Closes: #1064170

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 06 Apr 2024 04:16:59 +0000

mediastreamer2 (1:5.2.0+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Replace transitional build-dependency package
    libzxingcore-dev with the current libzxing-dev. (Closes: #1054380)

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Jan 2024 09:30:19 -0500

mediastreamer2 (1:5.2.0+dfsg-3) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Sat, 29 Jul 2023 19:35:20 +0200

mediastreamer2 (1:5.2.0+dfsg-2) experimental; urgency=medium

  * Ship libmsqogl.so in its own plugin package (Closes: #1040320).

 -- Dennis Filder <d.filder@web.de>  Sat, 08 Jul 2023 18:28:31 +0200

mediastreamer2 (1:5.2.0+dfsg-1) experimental; urgency=medium

  * New upstream release 5.2.0.
  * Bump soversion to 13 to reflect ABI break.
  * Comply with policy v4.6.2

 -- Dennis Filder <d.filder@web.de>  Mon, 19 Dec 2022 19:45:37 +0100

=== debian/control ===
Source: mediastreamer2
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Felix Lechner <felix.lechner@gmail.com>,
           Bernhard Schmidt <berni@debian.org>,
Build-Depends: cmake,
               debhelper-compat (= 13),
Build-Depends-Indep: doxygen <!nodoc>,
                     graphviz <!nodoc>,
Build-Depends-Arch: libasound2-dev [linux-any],
                    libavcodec-dev (>= 6:10~),
                    libavutil-dev (>= 6:10~),
                    libbcg729-dev (>= 1.1.1~),
                    libbcmatroska2-dev (>= 5.1~),
                    libbctoolbox-dev (>= 5.2.0~),
#                    libbv16-dev,
                    libbzrtp-dev (>= 5.2.0~),
                    libgles-dev,
                    libglew-dev,
                    libgsm1-dev,
                    libmbedtls-dev,
#                    libogg-dev, # already pulled in by libtheora-dev
                    libopus-dev,
                    libortp-dev (>= 1:5.2.0~),
                    libpcap-dev,
                    libpulse-dev,
                    libspandsp-dev,
                    libspeex-dev,
                    libspeexdsp-dev,
                    libsqlite3-dev,
                    libsrtp2-dev [!hurd-any !sparc],
                    libswscale-dev (>= 6:10~),
                    libtheora-dev,
                    libturbojpeg0-dev,
                    libupnp-dev,
                    libv4l-dev [linux-any],
                    libvpx-dev,
                    libx11-dev,
                    libxext-dev,
                    libxml2-dev,
                    libxv-dev,
# Upstream commit 98f948c reverted removal of libyuv, but I have
# no clue how or where any of it is used.  Disable it for now.
#                    libyuv-dev,
                    libzxing-dev,
                    mesa-common-dev,
                    pkg-config,
                    qtdeclarative5-dev,
                    qtbase5-dev,
                    xxd,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: libs
Homepage: https://www.linphone.org/technical-corner/mediastreamer2/overview
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2
Description: Multimedia streaming engine for telephony

Package: libmediastreamer13t64
Provides: ${t64:Provides}
Replaces: libmediastreamer13
Breaks: libmediastreamer13 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libmediastreamer-data (= ${source:Version}),
Recommends: mediastreamer2-plugin-opencore-amr,
 mediastreamer2-plugin-openh264,
 mediastreamer2-plugin-webrtc,
 mediastreamer2-plugin-x264,
 mediastreamer2-plugin-msqogl,
Suggests:
 mediastreamer2-plugin-codec2,
Description: Voice and video streaming engine for telephony (base)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the base library.

Package: libmediastreamer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmediastreamer13t64 (= ${binary:Version}),
         ${misc:Depends},
# the .pc file mentions these 2, so a Depends: is needed
# also the headers reference files from these 2
         libortp-dev,
         libbctoolbox-dev
Description: Development files for the mediastreamer2 library
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the development files for the development library.

Package: libmediastreamer-tools
Architecture: any
Multi-Arch: no
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (programs)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains some programs using the library.

Package: libmediastreamer-data
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Voice and video streaming engine for telephony (data files)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains architecture-independent data files.

Package: libmediastreamer-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: Voice and video streaming engine for telephony (documentation)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the developer documentation.

Package: mediastreamer2-plugin-msqogl
Conflicts: libmediastreamer12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (OpenGL-accelerated video support)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains a plugin needed for OpenGL-accelerated video
 telephony support.

=== debian/watch ===
version=4
opts=\
repack,\
compression=xz,\
repacksuffix=+dfsg,\
dversionmangle=s/\.dfsg\./-/;s/[\.\+]dfsg$//,\
filenamemangle=s/.*\/archive\/(\d\S+)\/mediastreamer2.*\.tar\.gz/mediastreamer2-$1\.tar\.gz/g \
  https://gitlab.linphone.org/BC/public/mediastreamer2/tags?sort=updated_desc .*/archive/([\d\.]+)/.*\.tar\.gz.*

## mediastreamer2 5.2.98+dfsg

=== debian/changelog ===
mediastreamer2 (1:5.2.98+dfsg-7) experimental; urgency=medium

  * No-change rebuild against zxing-cpp 2.2.1

 -- Bernhard Schmidt <berni@debian.org>  Tue, 02 Jan 2024 15:11:25 +0100

mediastreamer2 (1:5.2.98+dfsg-6) experimental; urgency=medium

  * Switch to using libzxing-dev (Closes: #1054380).
  * Build-dep on psmisc for elucidating buildd setup.
  * Build-dep on fonts-urw-base35 dotty diagrams.

 -- Dennis Filder <d.filder@web.de>  Sat, 28 Oct 2023 08:07:47 +0200

mediastreamer2 (1:5.2.98+dfsg-5) experimental; urgency=medium

  * Add shlibs.local entry for libbzrtp, too.

 -- Dennis Filder <d.filder@web.de>  Thu, 12 Oct 2023 17:56:21 +0200

mediastreamer2 (1:5.2.98+dfsg-4) experimental; urgency=medium

  * Add shlibs.local entry for libortp with version tightened to the
    one that links with the same libbctoolbox that libmediastreamer links
    with.

 -- Dennis Filder <d.filder@web.de>  Thu, 05 Oct 2023 20:18:13 +0200

mediastreamer2 (1:5.2.98+dfsg-3) experimental; urgency=medium

  * Add shlibs.local entry for bcmatroska2 with version tightened to the
    one that links with the same libbctoolbox that libmediastreamer links
    with.

 -- Dennis Filder <d.filder@web.de>  Mon, 02 Oct 2023 20:25:08 +0200

mediastreamer2 (1:5.2.98+dfsg-2) experimental; urgency=medium

  * Build without NEON on ARM architectures.

 -- Dennis Filder <d.filder@web.de>  Sat, 30 Sep 2023 17:27:57 +0200

mediastreamer2 (1:5.2.98+dfsg-1) experimental; urgency=medium

  * New upstream release 5.2.98.
  * Bump soname to due to ABI break.
  * Fix FTBFS for i386 on reproducible-builds.org.

 -- Dennis Filder <d.filder@web.de>  Sun, 03 Sep 2023 11:02:05 +0200

=== debian/control ===
--- 
+++ 
@@ -7,23 +7,25 @@
            Bernhard Schmidt <berni@debian.org>,
 Build-Depends: cmake,
                debhelper-compat (= 13),
+               psmisc,
 Build-Depends-Indep: doxygen <!nodoc>,
+                     fonts-urw-base35 <!nodoc>,
                      graphviz <!nodoc>,
 Build-Depends-Arch: libasound2-dev [linux-any],
                     libavcodec-dev (>= 6:10~),
                     libavutil-dev (>= 6:10~),
                     libbcg729-dev (>= 1.1.1~),
-                    libbcmatroska2-dev (>= 5.1~),
-                    libbctoolbox-dev (>= 5.2.0~),
+                    libbcmatroska2-dev (>= 5.2.0-3~),
+                    libbctoolbox-dev (>= 5.2.98~),
 #                    libbv16-dev,
-                    libbzrtp-dev (>= 5.2.0~),
+                    libbzrtp-dev (>= 5.2.98~),
                     libgles-dev,
                     libglew-dev,
                     libgsm1-dev,
                     libmbedtls-dev,
 #                    libogg-dev, # already pulled in by libtheora-dev
                     libopus-dev,
-                    libortp-dev (>= 1:5.2.0~),
+                    libortp-dev (>= 1:5.2.98~),
                     libpcap-dev,
                     libpulse-dev,
                     libspandsp-dev,
@@ -58,10 +60,7 @@
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2
 Description: Multimedia streaming engine for telephony
 
-Package: libmediastreamer13t64
-Provides: ${t64:Provides}
-Replaces: libmediastreamer13
-Breaks: libmediastreamer13 (<< ${source:Version})
+Package: libmediastreamer14
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends},
@@ -89,7 +88,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmediastreamer13t64 (= ${binary:Version}),
+Depends: libmediastreamer14 (= ${binary:Version}),
          ${misc:Depends},
 # the .pc file mentions these 2, so a Depends: is needed
 # also the headers reference files from these 2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

DEB_REQUESTED_PACKAGES := $(shell dh_listpackages)
when-in-build-profile     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-not-in-build-profile = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-building-package     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))
when-not-building-package = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Obtain the list of non-builtin targets once the Makefile has been
# generated.  If anyone knows of a better way, tell me!
ifneq (,$(wildcard obj-$(DEB_HOST_GNU_TYPE)/Makefile))
cmaketargets := $(shell find obj-$(DEB_HOST_GNU_TYPE) -type d -name '*.dir' -printf ' %f\n'|sed 's@.dir$$@@'|sort -u)
indeptargets := $(filter ms2-html-doc,$(cmaketargets))
archtargets := $(filter-out ms2-html-doc,$(cmaketargets))
endif

libpkgname := libmediastreamer14

features += -DENABLE_TOOLS=$(call when-building-package,libmediastreamer-tools,YES,NO)
features += -DENABLE_UNIT_TESTS=no
features += -DENABLE_STATIC=NO
features += -DENABLE_SHARED=$(call when-building-package,$(libpkgname),YES,NO)
features += -DENABLE_G729=$(call when-building-package,$(libpkgname),YES,NO) # libbcg729-dev
features += -DENABLE_G729B_CNG=$(call when-building-package,$(libpkgname),YES,NO) #  libbcg729-dev
features += -DENABLE_JPEG=$(call when-building-package,$(libpkgname),YES,NO) # libturbojpeg0-dev
features += -DENABLE_QRCODE=$(call when-building-package,$(libpkgname),YES,NO) # libzxingcore-dev
features += -DENABLE_PCAP=$(call when-building-package,$(libpkgname),YES,NO) # libpcap-dev
features += -DENABLE_G726=$(call when-building-package,$(libpkgname),YES,NO) # libspandsp-dev
features += -DENABLE_GSM=$(call when-building-package,$(libpkgname),YES,NO) # libgsm1-dev
features += -DENABLE_ZRTP=$(call when-building-package,$(libpkgname),YES,NO) # libbzrtp-dev
features += -DENABLE_MKV=$(call when-building-package,$(libpkgname),YES,NO) # libbcmatroska2-dev
features += -DENABLE_BV16=NO # $(call when-building-package,$(libpkgname),YES,NO) # libbv16-dev
features += -DENABLE_FFMPEG=$(call when-building-package,$(libpkgname),YES,NO) # libavcodec-dev libavutil-dev
features += -DENABLE_SOUND=$(call when-building-package,$(libpkgname),YES,NO)
features += -DENABLE_ALSA=$(call when-building-package,$(libpkgname),YES,NO) # libasound2-dev
features += -DENABLE_SPEEX_CODEC=$(call when-building-package,$(libpkgname),YES,NO) # libspeex-dev
features += -DENABLE_SPEEX_DSP=$(call when-building-package,$(libpkgname),YES,NO) # libspeexdsp-dev
features += -DENABLE_OPUS=$(call when-building-package,$(libpkgname),YES,NO) # libopus-dev
features += -DENABLE_PULSEAUDIO=$(call when-building-package,$(libpkgname),YES,NO) # libpulse-dev
features += -DENABLE_VIDEO=$(call when-building-package,$(libpkgname),YES,NO)
features += -DENABLE_THEORA=$(call when-building-package,$(libpkgname),YES,NO) # libtheora-dev
features += -DENABLE_QT_GL=$(call when-building-package,$(libpkgname),YES,NO) # qtdeclarative5-dev qtbase5-dev
# Under http://linphone.org/technical-corner/mediastreamer2?qt-technical_corner=3#qt-technical_corner
# it reads now (2021): "Please refer to public header files for
# Mediastreamer2 documentation."  I guess that means the docs are not
# considered worth maintaining anymore, but for now we still ship them.
features += -DENABLE_DOC=$(call when-building-package,libmediastreamer-doc,YES,NO) # doxygen

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
options += -DCMAKE_SKIP_RPATH=ON 
options += -DGIT_EXECUTABLE=/usr/share/bctoolbox/upstream-version-from-changelog
options += -DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM:%+dfsg=%)
options += -DDISABLE_BC_PACKAGE_SEARCH=$(call when-building-package,$(libpkgname),NO,YES)
options += -DDISABLE_SRTP_SEARCH=$(call when-building-package,$(libpkgname),NO,YES)
options += -DDISABLE_OPERATE_ON_SOURCE_CODE=$(call when-building-package,$(libpkgname),NO,YES)

# note that CMAKE_INSTALL_DATADIR must be an /absolute/ path here
# whereas in e.g. liblinphone it must be a path relative to /usr
options += -DCMAKE_INSTALL_DATADIR="/usr/share/mediastreamer2" # nowebcamCIF.jpg must go into images/ here

%:
	dh $@ --buildsystem=cmake --without autoreconf

override_dh_auto_configure:
	-pstree -chapglusTA $$$$ | sed 's@\[[10]m@@g'
	if ! [ -f debian/$(libpkgname).install ]; then \
		echo "HINT: You must update d/rules to have the new soname!" | grep --color '^.*$$' >&2 ; \
		false ; \
	fi
	dh_auto_configure -O--buildsystem=cmake -- \
	${features} \
	${options}

execute_before_dh_auto_install-indep:
ifeq (x,$(call when-not-building-package,libmediastreamer-dev,x))
	cp obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake \
	   obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake.orig
	truncate -s 0 obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake
endif

execute_after_dh_auto_install-indep:
ifeq (x,$(call when-not-building-package,libmediastreamer-dev,x))
	mv obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake.orig \
	   obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake
endif

execute_before_dh_install-indep:
	mkdir -p debian/tmp/usr/share/mediastreamer2/images && \
		cp -afv src/voip/nowebcamCIF.jpg debian/tmp/usr/share/mediastreamer2/images/nowebcamCIF.jpg

override_dh_auto_build-arch:
	dh_auto_build -O--buildsystem=cmake -- $(archtargets)

execute_after_dh_auto_build-arch:
#	false

override_dh_auto_build-indep:
# this tests for the -doc package only since the -data package needs
# nothing built
ifeq (x,$(call when-building-package,libmediastreamer-doc,x))
	echo DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)
	sed -i 's@^HAVE_DOT.*NO$$@HAVE_DOT = YES@' obj-$(DEB_HOST_GNU_TYPE)/help/Doxyfile
	sed -i 's@^RECURSIVE .*NO$$@RECURSIVE = YES@' obj-$(DEB_HOST_GNU_TYPE)/help/Doxyfile
	sed -i 's@^PREDEFINED .*= DOXYGEN \\$$@PREDEFINED = DOXYGEN MS2_DEPRECATED= \\@#Doxygen cannot parse __attribute__() expressions' obj-$(DEB_HOST_GNU_TYPE)/help/Doxyfile
	dh_auto_build -O--buildsystem=cmake -- $(call when-building-package,libmediastreamer-doc,ms2-html-doc)
endif

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake
